/*
 * debug - provides debug_printf(char *fmt, ...) function 
 *
 *
 * This work has been made possible in part by a grant from the Cisco
 * University Research Program Fund at Community Foundation Silicon Valley.
 *
 * This software is copyright (c) 2007 Swinburne University
 * of Technology, Melbourne, Australia (CRICOS number 00111D).
 * This software was developed by Warren Harrop (wazz@swin.edu.au)
 * while a PhD student at the Centre for Advanced Internet
 * Architectures (http://caia.swin.edu.au).
 *
 * This file is part of l3dgeworld_v1.0
 *
 * fakematter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * fakematter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * Seriously, it's version 0.0.1.
 *
 * You should have received a copy of the GNU General Public License
 * along with fakematter; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * \author Lucas Parry - CAIA, Swinburne University of Technology
 */
#include "debug.h"

int debug = 0;
/**
 * prints messages based on the status of a external int 'debug'.
 * \param format is the printf format string
 * \param ... variable number of arguments
 */
void debug_printf(char *format, ...)
{
  va_list args; // points to each unnamed arg in turn
  
  if (!debug)
    return;

  va_start(args,format); //make ap point to the 1st unnamed arg
  vprintf(format,args);
  va_end(args);
}
