#ifndef _gpoll_H_
#define _gpoll_H_

/*
 * gpoll v0.0.1
 *
 *
 * This work has been made possible in part by a grant from the Cisco
 * University Research Program Fund at Community Foundation Silicon Valley.
 *
 * This software is copyright (c) 2007 Swinburne University
 * of Technology, Melbourne, Australia (CRICOS number 00111D).
 * This software was developed by Warren Harrop (wazz@swin.edu.au)
 * while a PhD student at the Centre for Advanced Internet
 * Architectures (http://caia.swin.edu.au).
 *
 * This file is part of lcmon_v1.0
 *
 * fakematter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * gpoll is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * Seriously, it's version 0.0.1.
 *
 * You should have received a copy of the GNU General Public License
 * along with fakematter; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * \author Carl Javier - CAIA, Swinburne University of Technology
 * \author Lucas Parry - CAIA, Swinburne University of Technology
 */


#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include "l3dgecomms.h"
#include "debug.h"

#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <memory.h>

#define SAMPLE_SIZE (2500)
#define NUM_TOP (6)

#define MAX_PACKET_AGE_SECS (10)
#define MAX_PACKET_PER_PORT (3000)

#define PRINT_GAP_SEC (5)
#define PRINT_GAP_USEC (0)
#define AVERAGE_GAP_SEC (1)
#define AVERAGE_GAP_USEC (00000)

#define METRIC_ONE        (1)
#define METRIC_TWO        (2)
#define METRIC_THREE      (3)
#define METRIC_FOUR       (4)
#define METRIC_FIVE       (5)
#define METRIC_SIX        (6)
#define METRIC_INFO       (0)

#define FIELD_NAME        "n"
#define FIELD_VALUE       "v"
#define FIELD_RATE        "r"


#define _REENTRANT

//easy timing #defines
#define START_TIMER()  struct timeval start, finish, result; static int p=1; gettimeofday(&start,NULL); timeval_subtract(&result,&start,&finish); printf("gap was %li.%06lis.\n",result.tv_sec,result.tv_usec);
#define END_TIMER() gettimeofday(&finish,NULL);timeval_subtract(&result,&finish,&start);printf("execution %i took %li.%06lis,\t",p++,result.tv_sec,result.tv_usec);

struct greynet_host {
  int hostid;                 //the id number of the host
	struct in_addr ip_address;  //the ip address of this host
	int vlan;	                  //not used right now
	double pps;	                  //packets per second (average)
	

  struct in_addr lastAttacker;     //who attacked this host last

//  pthread_mutex_t host_mutex; // mutex for the entire host, lock this before changing anything
//  portlistitem_t *portListHead; //points to the start of a linked list of ports
};


//
// function declerations
//

void usage(void );

void writePort(int hostid, int port);

void writeLastAttackers(void );

void writePortInfo(void);

void writePPS(void);

void printLoop(void);

void writeSupercomputer(void);

void sendCVARNames (void);


#endif
