#ifndef _L3DGECOMMS_H_
#define _L3DGECOMMS_H_

/*
 * l3dgecomms 
 *
 *
 * This work has been made possible in part by a grant from the Cisco
 * University Research Program Fund at Community Foundation Silicon Valley.
 *
 * This software is copyright (c) 2007 Swinburne University
 * of Technology, Melbourne, Australia (CRICOS number 00111D).
 * This software was developed by Warren Harrop (wazz@swin.edu.au)
 * while a PhD student at the Centre for Advanced Internet
 * Architectures (http://caia.swin.edu.au).
 *
 * This file is part of l3dgeworld_v1.0
 *
 * fakematter is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * fakematter is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * Seriously, it's version 0.0.1.
 *
 * You should have received a copy of the GNU General Public License
 * along with fakematter; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * \author Lucas Parry - CAIA, Swinburne University of Technology
 */


#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include "debug.h"

#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <fcntl.h>
#include <errno.h>
#include <memory.h>


// hash defines

#define METRIC_ONE        (1)
#define METRIC_TWO        (2)
#define METRIC_THREE      (3)
#define METRIC_FOUR       (4)
#define METRIC_FIVE       (5)
#define METRIC_SIX        (6)
#define METRIC_SEVEN      (7)
#define METRIC_EIGHT      (8)
#define METRIC_NINE       (9)
#define METRIC_TEN        (10)
#define METRIC_INFO       (0)

#define FIELD_NAME        "n"
#define FIELD_VALUE       "v"
#define FIELD_RATE        "r"


// function declerations

void sendMessage(int hostid, int metric, char *field, char *value);
void setupComms(char *ipAddress);
void setupCommsWithPort(char *ipAddress,int port);
void closeComms(void);

#endif
